var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  build: () => build,
  dump: () => dump,
  transform: () => transform
});

// src/dump.ts
var import_node_fs2 = __toESM(require("fs"));
var import_node_path2 = __toESM(require("path"));
var import_leetcode_query = require("leetcode-query");
var import_node_fetch = __toESM(require("node-fetch"));
var import_ora = __toESM(require("ora"));
var import_turndown = __toESM(require("turndown"));

// src/constants.ts
var EXTS = {
  cpp: ".cpp",
  java: ".java",
  python: ".py",
  python3: ".py",
  c: ".c",
  csharp: ".cs",
  javascript: ".js",
  ruby: ".rb",
  swift: ".swift",
  golang: ".go",
  scala: ".scala",
  kotlin: ".kt",
  rust: ".rs",
  php: ".php",
  typescript: ".ts",
  racket: ".rkt",
  erlang: ".erl",
  elixir: ".ex"
};
var COMMENTS = {
  cpp: "//",
  java: "//",
  python: "#",
  python3: "#",
  c: "//",
  csharp: "//",
  javascript: "//",
  ruby: "#",
  swift: "//",
  golang: "//",
  scala: "//",
  kotlin: "//",
  rust: "//",
  php: "//",
  typescript: "//",
  racket: ";",
  erlang: "%",
  elixir: "#"
};
var LEETCODE_BASE = "https://leetcode.com";
var LEETCODE_DETAIL_BASE = LEETCODE_BASE + "/submissions/detail/";
var LEETCODE_SLUG_BASE = LEETCODE_BASE + "/problems/";
var README_TEMPLATE = `
# LeetCode Solutions

$card

## Solutions

| Problem | Difficulty | Tags | Solution |
| ------- | ---------- | ---- | -------- |
$table
`;
var DOC_TEMPLATE = `---
title: $title
---

# $title

$problem

$note

## Code

$code
`;

// src/utils.ts
var import_node_fs = __toESM(require("fs"));
var import_node_path = __toESM(require("path"));
var import_chalk = __toESM(require("chalk"));
function readable_memory(mem) {
  const units = ["B", "KB", "MB", "GB", "TB"];
  let unit = 0;
  while (mem > 1e3) {
    mem /= 1e3;
    unit++;
  }
  return `${mem.toFixed(2)} ${units[unit]}`;
}
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}
async function retry(func, max_retry2 = 3, cooldown = 1e3) {
  let error = null;
  for (let retry2 = 0; retry2 < max_retry2; retry2++) {
    try {
      return await func();
    } catch (err) {
      console.error(import_chalk.default.redBright(err));
      error = err;
      await sleep(cooldown);
    }
  }
  throw error;
}
var Logger = class {
  constructor(name = "", verbose = 3) {
    this.name = name;
    this.verbose = verbose;
    if (verbose) {
      this.log(`Verbose Mode: ${verbose}`);
    }
  }
  log(...args) {
    if (this.verbose >= 3) {
      console.log(import_chalk.default.gray(`[${this.name}]`), ...args);
    }
  }
  warn(...args) {
    if (this.verbose >= 2) {
      console.warn(import_chalk.default.yellowBright(`[${this.name}]`), ...args);
    }
  }
  error(...args) {
    if (this.verbose >= 1) {
      console.error(import_chalk.default.redBright(`[${this.name}]`), ...args);
    }
  }
};

// src/dump.ts
var turndown = new import_turndown.default().addRule("pre", {
  filter: "pre",
  replacement: (content, node) => "\n```\n" + node.textContent.replace("```", "\\`\\`\\`").trim() + "\n```\n"
}).addRule("sup", {
  filter: "sup",
  replacement: (content) => `^${content}`
});
var leetcode;
var max_retry = 3;
async function dump({
  session,
  output = import_node_path2.default.resolve("leetcode"),
  clean = true,
  cooldown = 250,
  timezone = "Asia/Taipei",
  pure = false,
  retry: retry2 = 3,
  verbose = true
}) {
  const { dir } = await setup({ timezone, retry: retry2, output, clean, session });
  const spinner = verbose ? (0, import_ora.default)({ text: "Scanning...", spinner: "bouncingBar" }).start() : null;
  const { list, ac } = await get_list();
  spinner == null ? void 0 : spinner.succeed(`Scan Done. (${list.length} Problems, ${ac.length} Accepted)`);
  await sleep(cooldown);
  const table = [];
  for (let i = 0; i < ac.length; i++) {
    spinner == null ? void 0 : spinner.start(`Dumping Submissions... (${i + 1}/${ac.length})`);
    const { titleSlug: slug } = ac[i];
    const problem = await get_problem(slug);
    spinner && (spinner.text += ` ${problem.questionFrontendId}. ${problem.title}`);
    const folder = import_node_path2.default.resolve(dir, `${problem.questionFrontendId}. ${problem.title}`);
    if (!import_node_fs2.default.existsSync(folder)) {
      import_node_fs2.default.mkdirSync(folder, { recursive: true });
    }
    import_node_fs2.default.writeFileSync(import_node_path2.default.resolve(folder, "README.md"), `# ${problem.questionFrontendId}. ${problem.title}

Tags: ${problem.topicTags.map((t) => "`" + t.name + "`").join(", ")}

${turndown.turndown(problem.content)}`);
    import_node_fs2.default.writeFileSync(import_node_path2.default.resolve(folder, "NOTE.md"), problem.note);
    const submissions = await get_submissions(slug);
    spinner && (spinner.text += ` [${Object.keys(submissions).join(", ")}]`);
    await sleep(cooldown);
    const row = [
      `[${problem.questionFrontendId}. ${problem.title}](./${encodeURI(import_node_path2.default.basename(folder))}) [\u{1F517}](${LEETCODE_SLUG_BASE}${slug}/)`,
      problem.difficulty,
      problem.topicTags.map((t) => "`" + t.name + "`").join(", "),
      []
    ];
    for (const lang in submissions) {
      const ext = EXTS[lang];
      const file = import_node_path2.default.resolve(folder, `${slug}${ext}`);
      if (!import_node_fs2.default.existsSync(file)) {
        const submission = await get_submission(submissions[lang].id);
        const info = `${COMMENTS[lang]} ${problem.questionFrontendId}. ${problem.title} (${new Date(+submissions[lang].timestamp * 1e3).toLocaleDateString()})
${COMMENTS[lang]} Runtime: ${submission.runtime} ms (${submission.runtime_percentile.toFixed(2)}%) Memory: ${readable_memory(submission.memory)} (${submission.memory_percentile.toFixed(2)}%) 

`;
        import_node_fs2.default.writeFileSync(file, `${pure ? "" : info}${submission.code}`);
        row[3].push(`[${lang}](${encodeURI(`./${import_node_path2.default.basename(folder)}/${slug}${ext}`)})`);
        await sleep(cooldown);
      }
    }
    row[3].sort();
    table.push(row);
    spinner == null ? void 0 : spinner.succeed(`Dumped ${problem.questionFrontendId}. ${problem.title} [${Object.keys(submissions).join(", ")}]`);
  }
  spinner == null ? void 0 : spinner.succeed("Submissions Dumped.");
  import_node_fs2.default.writeFileSync(import_node_path2.default.resolve(dir, "README.md"), await create_toc(table));
}
async function setup({
  session,
  output,
  clean,
  timezone,
  retry: retry2
}) {
  process.env.TZ = timezone;
  max_retry = retry2;
  const dir = import_node_path2.default.resolve(output);
  if (import_node_fs2.default.existsSync(dir) && clean) {
    import_node_fs2.default.rmSync(dir, { recursive: true });
  }
  if (!import_node_fs2.default.existsSync(dir)) {
    import_node_fs2.default.mkdirSync(dir, { recursive: true });
  }
  const credential = new import_leetcode_query.Credential();
  await credential.init(session);
  leetcode = new import_leetcode_query.LeetCode(credential);
  return { dir };
}
async function get_list() {
  const ql = `query allQuestionsStatusesRaw { allQuestions: allQuestionsRaw { titleSlug questionFrontendId status } }`;
  const json = await retry(() => leetcode.graphql({
    query: ql,
    operationName: "allQuestionsStatusesRaw",
    variables: {}
  }), max_retry);
  const list = json.data.allQuestions;
  const ac = list.filter((item) => item.status === "ac").sort((a, b) => +a.questionFrontendId - +b.questionFrontendId);
  return { list, ac };
}
async function get_problem(slug) {
  const ql = `
    query questionData($slug: String!) {
        question(titleSlug: $slug) {
            questionFrontendId title content difficulty similarQuestions categoryTitle stats topicTags { name slug } note
        }
    }`;
  const json = (await retry(() => leetcode.graphql({ query: ql, operationName: "questionData", variables: { slug } }), max_retry)).data.question;
  json.similarQuestions = JSON.parse(json.similarQuestions);
  json.stats = JSON.parse(json.stats);
  return json;
}
async function get_submissions(slug) {
  const ql = `
    query Submissions($offset: Int!, $limit: Int!, $last: String, $slug: String!) {
        submissionList(offset: $offset, limit: $limit, lastKey: $last, questionSlug: $slug) {
            hasNext
            submissions { id statusDisplay lang runtime timestamp }
        }
    }`;
  const list = {};
  for (let i = 0; i < 10; i++) {
    const json = await retry(() => leetcode.graphql({
      query: ql,
      operationName: "Submissions",
      variables: { slug, offset: 0 * 20, limit: 20 }
    }), max_retry);
    const { submissions, hasNext } = json.data.submissionList;
    for (const submission of submissions) {
      const { id, statusDisplay, lang, runtime, timestamp } = submission;
      if (statusDisplay !== "Accepted") {
        continue;
      }
      if (!list[lang] || parseInt(runtime) < parseInt(list[lang].runtime) || parseInt(runtime) === parseInt(list[lang].runtime) && parseInt(timestamp) > parseInt(list[lang].timestamp)) {
        list[lang] = { id, timestamp, runtime };
      }
    }
    if (submissions.length === 0 || !hasNext) {
      break;
    }
  }
  return list;
}
async function get_submission(id) {
  return await retry(async () => {
    var _a;
    const res = await (0, import_node_fetch.default)(`${LEETCODE_DETAIL_BASE}${id}/`, {
      headers: {
        Cookie: `LEETCODE_SESSION=${leetcode.credential.session}`,
        Referer: LEETCODE_BASE
      }
    });
    const raw = await res.text();
    const data = (_a = raw.match(/var pageData = ({[^]+?});/)) == null ? void 0 : _a[1];
    const json = new Function("return " + data)();
    const result = {
      runtime: +json.runtime,
      runtime_distribution: json.runtimeDistributionFormatted ? JSON.parse(json.runtimeDistributionFormatted).distribution.map((item) => [+item[0], item[1]]) : null,
      runtime_percentile: 0,
      memory: +json.memory,
      memory_distribution: json.memoryDistributionFormatted ? JSON.parse(json.memoryDistributionFormatted).distribution.map((item) => [+item[0], item[1]]) : null,
      memory_percentile: 0,
      code: json.submissionCode
    };
    if (result.runtime_distribution) {
      result.runtime_percentile = result.runtime_distribution.reduce((acc, [usage, p]) => acc + (usage >= result.runtime ? p : 0), 0);
    }
    if (result.memory_distribution) {
      result.memory_percentile = result.memory_distribution.reduce((acc, [usage, p]) => acc + (usage >= result.memory / 1e3 ? p : 0), 0);
    }
    return result;
  }, max_retry);
}
async function create_toc(table) {
  const username = await get_username();
  const card = `[![LeetCode Stats Card](https://leetcode.card.workers.dev/?username=${username})](https://leetcode.com/${username}/)`;
  const table_str = table.map(([title, difficulty, tags, solutions]) => `| ${title} | ${difficulty} | ${tags} | ${solutions.join(" \\| ")} |`).join("\n");
  return README_TEMPLATE.replace("$card", card).replace("$table", table_str);
}
async function get_username() {
  return (await retry(() => leetcode.graphql({
    query: `query globalData { userStatus { username } }`,
    operationName: "globalData",
    variables: {}
  }), max_retry)).data.userStatus.username;
}

// src/build.ts
var import_node_child_process = require("child_process");
var import_node_path4 = __toESM(require("path"));
var import_fs_extra = __toESM(require("fs-extra"));

// src/transform.ts
var import_node_fs3 = __toESM(require("fs"));
var import_node_path3 = __toESM(require("path"));
async function transform(source, output, verbose = false) {
  const logger = new Logger("Transform", verbose ? 3 : 0);
  source = import_node_path3.default.resolve(source);
  output = import_node_path3.default.resolve(output);
  logger.log(`Source: ${source}`);
  logger.log(`Output: ${output}`);
  if (!import_node_fs3.default.existsSync(source)) {
    throw new Error(`[Transform] ${source} does not exist`);
  }
  if (import_node_fs3.default.existsSync(output)) {
    throw new Error(`[Transform] ${output} already exists`);
  }
  try {
    import_node_fs3.default.mkdirSync(output, { recursive: true });
    import_node_fs3.default.writeFileSync(import_node_path3.default.resolve(output, "README.md"), fix(import_node_fs3.default.readFileSync(import_node_path3.default.resolve(source, "README.md"), "utf8")));
    logger.log("Root level README.md written");
    const problems = import_node_fs3.default.readdirSync(source).filter((name) => import_node_fs3.default.statSync(import_node_path3.default.resolve(source, name)).isDirectory());
    logger.log(`${problems.length} problems found`);
    for (const problem of problems) {
      const slug = problem.replace(/(\d+)\./, "$1").replace(/\s+/g, "-").replace("'", "").toLowerCase();
      import_node_fs3.default.mkdirSync(import_node_path3.default.resolve(output, slug), { recursive: true });
      const doc = gen_doc(import_node_path3.default.resolve(source, problem));
      import_node_fs3.default.writeFileSync(import_node_path3.default.resolve(output, slug, "index.md"), doc);
      logger.log(`${problem} written`);
    }
    logger.log("Transform Complete");
  } catch (err) {
    logger.error(err);
  }
}
function gen_doc(src) {
  const title = import_node_path3.default.basename(src);
  const problem = import_node_fs3.default.readFileSync(import_node_path3.default.resolve(src, "README.md"), "utf8");
  const note = import_node_fs3.default.readFileSync(import_node_path3.default.resolve(src, "NOTE.md"), "utf8");
  const sources = import_node_fs3.default.readdirSync(src).filter((name) => !name.endsWith(".md"));
  const solutions = sources.map((name) => {
    const solution = import_node_fs3.default.readFileSync(import_node_path3.default.resolve(src, name), "utf8");
    return { type: import_node_path3.default.extname(name).slice(1), solution };
  });
  return DOC_TEMPLATE.replace(/\$title/g, title).replace(/\$note/g, note).replace(/\$problem/g, problem.replace(/#[^\n]+\n/, "<br>\n\n")).replace(/\$code/g, solutions.map(({ type, solution }) => `### ${type.toUpperCase()}

\`\`\`${type}
${solution}
\`\`\``).join("\n\n"));
}
function fix(source) {
  return source.replace(/\(\.\/\d{1,4}\.[^)]+\)/g, (match) => match.replace(/(\d+)\./, "$1").replace(/(%20)+/g, "-").replace("'", "").toLowerCase()).replace(/([^.]\/)[^.]+\.([\w]+\))/g, "$1#$2");
}

// src/build.ts
async function build(source, output, config, verbose = false) {
  const logger = new Logger("Build", verbose ? 3 : 0);
  source = import_node_path4.default.resolve(source);
  output = import_node_path4.default.resolve(output);
  logger.log(`Building site to ${output}`);
  if (!import_fs_extra.default.existsSync(source)) {
    throw new Error(`${source} does not exist`);
  }
  const workspace = import_fs_extra.default.mkdtempSync("site-tmp-");
  const tmp = import_node_path4.default.resolve(workspace, "source");
  import_fs_extra.default.symlinkSync(import_node_path4.default.resolve(__dirname, "../node_modules"), import_node_path4.default.resolve(workspace, "node_modules"));
  logger.log("Symlinked node_modules");
  transform(source, tmp, verbose);
  logger.log("Site transformed");
  if (import_fs_extra.default.existsSync(output)) {
    import_fs_extra.default.rmSync(output, { recursive: true });
  }
  await build_site(workspace, output, config ? JSON.parse(import_fs_extra.default.readFileSync(config, "utf8")) : {
    plugins: [[require.resolve("@vuepress/plugin-search"), {}]],
    title: "LeetCode Solutions"
  });
  import_fs_extra.default.rmSync(workspace, { recursive: true });
  logger.log("Build Complete");
}
async function build_site(workspace, dest, config) {
  const exe = import_node_path4.default.resolve(require.resolve("vuepress"), "../../bin/vuepress.js");
  import_fs_extra.default.mkdirSync(import_node_path4.default.resolve(workspace, "source", ".vuepress"), { recursive: true });
  import_fs_extra.default.writeFileSync(import_node_path4.default.resolve(workspace, "source", ".vuepress", "config.ts"), `export default ${JSON.stringify(config, null, 4)};`);
  (0, import_node_child_process.execSync)(`${exe} build source --dest site`, { stdio: "inherit", cwd: workspace });
  import_fs_extra.default.moveSync(import_node_path4.default.resolve(workspace, "site"), dest, { overwrite: true });
}
module.exports = __toCommonJS(src_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  build,
  dump,
  transform
});
